<?php

/*********************************************************************

 エントリーパス調整プラグイン (2016/02/06)

 freo.jp
 customize by 32877(http://32877.xii.jp)

*********************************************************************/

/* メイン処理 */
function freo_init_entry_path()
{
	global $freo;

	//パラメータ取得
	if (isset($freo->parameters[0])) {
		$parameters = array();
		$i          = -1;
		while (isset($freo->parameters[++$i])) {
			if (!$freo->parameters[$i]) {
				continue;
			}

			$parameters[] = $freo->parameters[$i];
		}
		$parameter = implode('/', $parameters);
	} else {
		$parameter = null;
	}

	if ($parameter) {
		//エントリー確認(ID)
		$stmt = $freo->pdo->prepare('SELECT id FROM ' . FREO_DATABASE_PREFIX . 'entries WHERE id = :id');
		$stmt->bindValue(':id', $parameter);
		$flag = $stmt->execute();
		if (!$flag) {
			freo_error($stmt->errorInfo());
		}
		if ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
			$mode = 'view';
		}

		if ($freo->config['plugin']['entry_path']['code_path'] == 'yes') {
			//エントリー確認(code)
			$stmt = $freo->pdo->prepare('SELECT code FROM ' . FREO_DATABASE_PREFIX . 'entries WHERE code = :code');
			$stmt->bindValue(':code', $parameter);
			$flag = $stmt->execute();
			if (!$flag) {
				freo_error($stmt->errorInfo());
			}
			if ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$mode = 'view';
			}
			if ($freo->config['plugin']['entry_path']['page_path'] == 'yes') {
				//ページID確認(code)
				$stmt = $freo->pdo->prepare('SELECT id FROM ' . FREO_DATABASE_PREFIX . 'pages WHERE id = :code');
				$stmt->bindValue(':code', $parameter);
				$flag = $stmt->execute();
				if (!$flag) {
					freo_error($stmt->errorInfo());
				}
				if ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
					$mode = 'page';
				}
			}
		}
		//パス調整処理
		if (isset($mode)) {
			$_REQUEST['freo']['mode'] = $mode;
			$_REQUEST['freo']['work'] = $freo->parameters[0];

			$freo->parameters = array_merge(array($mode), $freo->parameters);
		}
	}

	return;
}

?>
